"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = exports.PaneIcon = void 0;
var _input = _interopRequireDefault(require("antd/lib/input"));
var _tabs = _interopRequireDefault(require("antd/lib/tabs"));
var _collapse = _interopRequireDefault(require("antd/lib/collapse"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));
var _react = _interopRequireDefault(require("react"));
var _bind = _interopRequireDefault(require("classnames/bind"));
var _lodashEs = require("lodash-es");
var _indexModule = _interopRequireDefault(require("./index.module.less"));
var _Icon = _interopRequireDefault(require("../Icon"));
var _List = _interopRequireDefault(require("../components/List"));
var _Component = _interopRequireDefault(require("../components/Component"));
var _store = _interopRequireDefault(require("../store"));
var _transform = _interopRequireWildcard(require("../utils/transform"));
var _icons = require("@ant-design/icons");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var store = new _store["default"]();
var cx = _bind["default"].bind(_indexModule["default"]);
var ComponentPane = exports["default"] = /*#__PURE__*/function (_React$Component) {
  function ComponentPane(props) {
    var _this;
    _this = _React$Component.call(this, props) || this;
    _this.state = {
      groups: [],
      filter: [],
      keyword: ''
    };
    _this.store = store;
    _this.t = void 0;
    _this.getStrKeywords = void 0;
    _this.getFilteredComponents = (0, _lodashEs.debounce)(function () {
      var _this$state = _this.state,
        _this$state$groups = _this$state.groups,
        groups = _this$state$groups === void 0 ? [] : _this$state$groups,
        keyword = _this$state.keyword;
      if (!keyword) {
        _this.setState({
          filter: groups
        });
        return;
      }
      var filter = groups.map(function (group) {
        return (0, _extends2["default"])({}, group, {
          categories: group.categories.map(function (category) {
            return (0, _extends2["default"])({}, category, {
              components: category.components.filter(function (c) {
                var keyToSearch = _this.getKeyToSearch(c);
                if (c.snippets) {
                  c.snippets.map(function (item) {
                    keyToSearch += "_" + _this.getKeyToSearch(item);
                  });
                }
                return keyToSearch.includes(keyword);
              })
            });
          }).filter(function (c) {
            var _c$components;
            return c === null || c === void 0 ? void 0 : (_c$components = c.components) === null || _c$components === void 0 ? void 0 : _c$components.length;
          })
        });
      });
      _this.setState({
        filter: filter
      });
    }, 200);
    _this.registerAdditive = function (shell) {
      if (!shell || shell.dataset.registered) {
        return;
      }
      function getSnippetId(elem) {
        if (!elem) {
          return null;
        }
        while (shell !== elem) {
          if (elem.classList.contains('snippet')) {
            return elem.dataset.id;
          }
          elem = elem.parentNode;
        }
        return null;
      }
      var _this$props = _this.props,
        common = _this$props.common,
        project = _this$props.project;
      var _dragon = common.designerCabin.dragon;
      if (!_dragon) {
        return;
      }

      // eslint-disable-next-line
      var click = function click(e) {};
      shell.addEventListener('click', click);
      _dragon.from(shell, function (e) {
        var doc = project.getCurrentDocument();
        var id = getSnippetId(e.target);
        if (!doc || !id) {
          return false;
        }
        var dragTarget = {
          type: 'nodedata',
          data: _this.store.getSnippetById(id)
        };
        return dragTarget;
      });
      shell.dataset.registered = 'true';
    };
    _this.handleSearch = function (v) {
      var _v$target;
      var _keyword = v === null || v === void 0 ? void 0 : (_v$target = v.target) === null || _v$target === void 0 ? void 0 : _v$target.value;
      _this.setState({
        keyword: _keyword.toLowerCase()
      });
      _this.getFilteredComponents();
    };
    _this.t = (0, _transform.getTextReader)(props.lang);
    _this.getStrKeywords = function (keywords) {
      if (typeof keywords === 'string') {
        return keywords;
      }
      if (keywords && Array.isArray(keywords) && keywords.length) {
        return keywords.map(function (keyword) {
          return _this.t(keyword);
        }).join('-');
      }
      return '';
    };
    return _this;
  }
  (0, _inheritsLoose2["default"])(ComponentPane, _React$Component);
  var _proto = ComponentPane.prototype;
  _proto.getKeyToSearch = function getKeyToSearch(c) {
    var _schema;
    var strTitle = this.t(c.title);
    var strComponentName = this.t((_schema = c.schema) === null || _schema === void 0 ? void 0 : _schema.componentName);
    var strDescription = 'description' in c ? this.t(c.description) : '';
    var strKeywords = 'keywords' in c ? this.getStrKeywords(c.keywords || []) : '';
    return (strTitle + "#" + strComponentName + "#" + strDescription + "#" + strKeywords).toLowerCase();
  };
  _proto.componentDidMount = function componentDidMount() {
    var _this$props2 = this.props,
      editor = _this$props2.editor,
      material = _this$props2.material,
      event = _this$props2.event;
    if (!editor) {
      this.initComponentList();
      return;
    }
    var assets = material.getAssets();
    if (assets) {
      this.initComponentList();
    } else {
      console.warn('[ComponentsPane]: assets not ready, wait for assets ready event.');
    }
    event.on('trunk.change', this.initComponentList.bind(this));
    material.onChangeAssets(this.initComponentList.bind(this));
  }

  /**
   * 初始化组件列表
   * TODO: 无副作用，可多次执行
   */;
  _proto.initComponentList = function initComponentList() {
    var material = this.props.material;
    var rawData = material.getAssets();
    var meta = (0, _transform["default"])(rawData, this.t);
    var groups = meta.groups,
      snippets = meta.snippets;
    this.store.setSnippets(snippets);
    this.setState({
      groups: groups,
      filter: groups
    });
  };
  _proto.renderEmptyContent = function renderEmptyContent() {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: cx('empty')
    }, /*#__PURE__*/_react["default"].createElement("img", {
      src: "//g.alicdn.com/uxcore/pic/empty.png"
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: cx('content')
    }, this.t((0, _transform.createI18n)('暂无组件，请在物料站点添加', 'No components, please add materials'))));
  };
  _proto.renderContent = function renderContent() {
    var _this2 = this;
    var _this$state2 = this.state,
      _this$state2$filter = _this$state2.filter,
      filter = _this$state2$filter === void 0 ? [] : _this$state2$filter,
      keyword = _this$state2.keyword;
    var hasContent = filter.filter(function (item) {
      var _item$categories;
      return item === null || item === void 0 ? void 0 : (_item$categories = item.categories) === null || _item$categories === void 0 ? void 0 : _item$categories.filter(function (category) {
        var _category$components;
        return category === null || category === void 0 ? void 0 : (_category$components = category.components) === null || _category$components === void 0 ? void 0 : _category$components.length;
      }).length;
    }).length;
    if (!hasContent) {
      return this.renderEmptyContent();
    }
    var panelStyle = {
      margin: '15px 10px',
      background: '#fff',
      borderRadius: '4px',
      border: 'none'
    };
    if (keyword) {
      var items = [];
      filter.map(function (group) {
        var categories = group.categories;
        var _items = categories.map(function (category) {
          var cname = _this2.t(category.name);
          var components = category.components;
          return {
            key: cname,
            label: cname,
            children: /*#__PURE__*/_react["default"].createElement(_List["default"], null, components.map(function (component) {
              var componentName = component.componentName,
                _component$snippets = component.snippets,
                snippets = _component$snippets === void 0 ? [] : _component$snippets;
              return snippets.filter(function (snippet) {
                return snippet.id && _this2.getKeyToSearch(snippet).toLowerCase().includes(keyword);
              }).map(function (snippet) {
                return /*#__PURE__*/_react["default"].createElement(_Component["default"], {
                  data: {
                    title: snippet.title || component.title,
                    icon: snippet.screenshot || component.icon,
                    snippets: [snippet]
                  },
                  key: _this2.t(group.name) + "_" + _this2.t(componentName) + "_" + _this2.t(snippet.title),
                  t: _this2.t
                });
              });
            })),
            style: panelStyle
          };
        });
        items.push.apply(items, _items);
      });
      return /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.registerAdditive,
        className: cx('filtered-content')
      }, /*#__PURE__*/_react["default"].createElement(_collapse["default"], {
        className: cx('category'),
        defaultActiveKey: items.map(function (item) {
          return item.key;
        }),
        bordered: false,
        items: items,
        expandIconPosition: "end"
      }));
    }
    var tabs = filter.map(function (group) {
      var categories = group.categories;
      var items = categories.map(function (category) {
        var cname = _this2.t(category.name);
        var components = category.components;
        return {
          key: cname,
          label: cname,
          children: /*#__PURE__*/_react["default"].createElement(_List["default"], null, components.map(function (component) {
            var componentName = component.componentName,
              _component$snippets2 = component.snippets,
              snippets = _component$snippets2 === void 0 ? [] : _component$snippets2;
            return snippets.filter(function (snippet) {
              return snippet.id;
            }).map(function (snippet) {
              return /*#__PURE__*/_react["default"].createElement(_Component["default"], {
                data: {
                  title: snippet.title || component.title,
                  icon: snippet.screenshot || component.icon,
                  snippets: [snippet]
                },
                t: _this2.t,
                key: _this2.t(group.name) + "_" + _this2.t(componentName) + "_" + _this2.t(snippet.title)
              });
            });
          })),
          style: panelStyle
        };
      });
      return {
        key: _this2.t(group.name),
        label: _this2.t(group.name),
        children: /*#__PURE__*/_react["default"].createElement("div", {
          ref: _this2.registerAdditive
        }, /*#__PURE__*/_react["default"].createElement(_collapse["default"], {
          className: cx('category'),
          defaultActiveKey: items.map(function (item) {
            return item.key;
          }),
          bordered: false,
          items: items,
          expandIconPosition: "end"
        }))
      };
    });
    return /*#__PURE__*/_react["default"].createElement(_tabs["default"], {
      className: cx('tabs'),
      tabBarGutter: 0,
      animated: true,
      items: tabs
    });
  };
  _proto.render = function render() {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: cx('lowcode-component-panel')
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: cx('header')
    }, /*#__PURE__*/_react["default"].createElement(_input["default"], {
      placeholder: this.t((0, _transform.createI18n)('搜索组件', 'Search components')),
      suffix: /*#__PURE__*/_react["default"].createElement(_icons.SearchOutlined, {
        className: cx('greyFont')
      }),
      onPressEnter: this.handleSearch,
      className: cx('searchInput')
    })), this.renderContent());
  };
  return ComponentPane;
}(_react["default"].Component);
ComponentPane.displayName = 'LowcodeComponentPane';
ComponentPane.defaultProps = {
  lang: 'zh_CN'
};
var PaneIcon = exports.PaneIcon = _Icon["default"];